import { FormGroup } from '@angular/forms';
import { ActivatedRoute, Router } from '@angular/router';
import { BindQueryParamsOptions, QueryParamParams, SyncDefsOptions } from './types';
import { QueryParamDef } from './QueryParamDef';
export declare class BindQueryParamsManager<T = any> {
    private router;
    private activeRoute;
    private options;
    private defs;
    private group;
    private $destroy;
    private defsSynced;
    connect(group: FormGroup): this;
    constructor(router: Router, activeRoute: ActivatedRoute, defs: QueryParamParams<T>[] | QueryParamParams<T>, options: BindQueryParamsOptions);
    onInit(): void;
    destroy(): void;
    getDef(queryKey: keyof T): QueryParamDef<T> | undefined;
    parse(queryParams: Partial<T>): Record<string, unknown>;
    syncAllDefs(options?: SyncDefsOptions): void;
    syncDefs(queryKeys: (keyof T & string) | (keyof T & string)[], options?: SyncDefsOptions): void;
    paramExists(queryKey: keyof T): boolean;
    someParamExists(): boolean;
    private updateQueryParams;
    private updateControl;
}
